# Ring 標準ライブラリ
# アプリケーション用の汎用関数とクラス
# 2016, Mahmoud Fayed <msfclipper@yahoo.com>
# 2016, CalmoSoft <calmosoft@gmail.com>
Load "stdlib.ring"

# Application Path
Puts("AppPath() のテスト")
See AppPath() + nl

# Execute a function nCount of times
Puts("Times() のテスト")
Times ( 3 , func { see "Hello, World!" + nl } )

# Execute a function on each list item
Puts("Map() のテスト")
See Map( 1:10, func x { return x*x } )

# Test the Value function to copy a list or object
Puts("Value() のテスト")
See value(1:10)

# Test the Filter function
Puts("Filter() のテスト")
See Filter( 1:10 , func x { if x <= 5 return true else return false ok } )

# Test the Split function
Puts("Split() のテスト")
See Split("one two three four five"," ")

# Test the Newlist function
Puts("Newlist() のテスト")
a1 = 3
a2 = 5
chrArray = newlist(a1,a2)
numArray = newlist(a1,a2)
chrArray[1][1] = "Hello"
numArray[1][1]  = 987.2
See chrArray[1][1] + nl
See numArray[1][1] + nl

# Return a copy with the first letter capitalized
Puts("Capitalized() のテスト")
See capitalized("welcome to the Ring Programming Language")

# Test if the character is a special character?
Puts("Isspecial() のテスト")
See "Isspecial  = " + isSpecial("%") + nl

# Test if the character is a vowel character?
Puts("Isvowel() のテスト")
See "Isvowel = " + isVowel("c") + nl

# Return the number of lines (lines count) in a text file
Puts("Linecount() のテスト")
See "the number of lines = " + lineCount("test.ring")

# Return the factorial of number
Puts("Factorial() のテスト")
see "6 factorial is : " + Factorial(6)

# Return the Fibonacci number
Puts("Fibonacci() のテスト")
see "6 Fibonacci is : " + Fibonacci(6)

# Check whether a number is prime or not
Puts("Isprime() のテスト")
flag = isPrime(16)
if flag = 1 see "16 is a prime number"
else see "16 is not a prime number" ok

# Returns an Integer value indicating the sign of a number.
Puts("Sign() のテスト")
see "sign of 12 is = " + sign(12) + nl

# Test List2File
Puts("List2File() のテスト")
list2file(1:100,"myfile.txt")

# Test File2List
Puts("File2List() のテスト")
see len(file2list("myfile.txt"))

# Returns true if the given string ends with the specified substring. Trailing white spaces are ignored.
Puts("Endswith() のテスト")
see endsWith("CalmoSoft", "Soft") + nl

# Returns true if the given string starts with the specified substring. Leading white spaces are ignored.
Puts("Startswith() のテスト")
see Startswith("CalmoSoft", "Calmo") + nl

# Finding of the greatest common divisor of two integers.
Puts("Gcd() のテスト")
see gcd (24, 32) + nl

# Compute the least common multiple of two integers.
Puts("Lcm() のテスト")
see Lcm(24,36) + nl

# Compute the product of a list of integers.
Puts("Prodlist() のテスト")
aList = [1,2,3,4,5]
see Prodlist(aList) + nl

# Compute the sum of a list of integers.
Puts("Sumlist() のテスト")
aList = [1,2,3,4,5]
see Sumlist(aList) + nl

# Compute the sum of a list of integers.
Puts("Evenorodd() のテスト")
nr = 17
see Evenorodd(nr) + nl

# Compute the factors of a positive integer.
Puts("Factors() のテスト")
n = 45
aList = factors(n)
see "Factors of " + n + " = "
for i = 1 to len(aList)
    see "" + aList[i] + " "
next

# Check if a sequence of characters is a palindrome or not.
Puts("Palindrome() のテスト")
cString = "radar"
Palindrome(cString)

# Check whether a given year is a leap year in the Gregorian calendar.
Puts("Isleapyear() のテスト")
year = 2016
if Isleapyear(year) see "" + year + " is a leap year."
else see "" + year + " is not a leap year." ok

# Compute the sequence of binary digits for a given non-negative integer.
Puts("Binarydigits() のテスト")
b = 35
see "Binary digits of " + b + " = "
see Binarydigits(b) + nl

# Multiply two matrices together.
Puts("Matrixmulti() のテスト")
A = [[1,2,3], [4,5,6], [7,8,9]]
B = [[1,0,0], [0,1,0], [0,0,1]]
see Matrixmulti(A, B)

# Transpose an arbitrarily sized rectangular Matrix.
Puts("Matrixtrans() のテスト")
matrix = [[78,19,30,12,36], [49,10,65,42,50], [30,93,24,78,10], [39,68,27,64,29]]
see Matrixtrans(matrix)

# Return the day of the week of given date.
Puts("Dayofweek() のテスト")
date = "2016-04-24"
see "Data : " + date + " - Day : " + Dayofweek(date) + nl

# Friday the 13th between start and end year.
Puts("Fridays() のテスト")
year1 = 2010
year2 = 2020
Fridays(year1, year2)

# Generates all permutations of n different numerals
Puts("Permutation() のテスト")
list = [1, 2, 3, 4]
for perm = 1 to 24
     for i = 1 to len(list)
          see list[i] + " "
     next
     see nl
     Permutation(list)
next


# Sleep for the given amount of time.
Puts("Sleep() のテスト")
see "Wait 3 Seconds!"
Sleep(3)
see nl

# Read a file line by line.
Puts("Readline() のテスト")
fp = fopen("test.ring","r")
while not feof(fp)
See Readline(fp) end
fclose(fp)

# Return a position of a substring starting from a given position in a string.
Puts("Substring() のテスト")
a = "abcxyzqweabc"
b = "abc"
i = 4
see substring(a,b,i)

# Change substring from given position for given position with a substring.
Puts("Changestring() のテスト")
see Changestring("Rmasdg",2,5,"in")

# Test print()
print("\nHello, World\n\nHow are you? \t\t I'm fine!\n")
x=10 y=20
print("\nx value = #{x} , y value = #{y} \n")

# Check directory
see "Check dir : b:\ring " 
puts( DirExists("b:\ring") )
see "Check dir : C:\ring " 
Puts( DirExists("C:\ring") )

# ディレクトリの作成
puts("ディレクトリの作成 : myfolder")
makedir("myfolder")

# GetString() and GetNumber() のテスト
See "Test getstring() and getnumber()"+nl
See "Enter your name ?" 
cName = getstring()
see "Your name is : " + cName + nl
See "Enter your Age? "
nAge = getnumber()
nAge++
See "Your age after 1 year : " + nAge + nl

# Sort a two-dimensional list on the first index.
Puts("sortFirstSecond() のテスト")
aList = [[2,2], [1,2], [3,2], [3,1], [1,1]]
sortFirstSecond(aList, 1)

for n=1 to len(aList)
    for m=1 to 2
        see string(aList[n][m]) + " "
    next
    see nl
next

# Sort a two-dimensional list on the second index.
Puts("sortFirstSecond() のテスト")
aList = [[2,2], [1,2], [3,2], [3,1], [1,1]]
sortFirstSecond(aList, 2)

for n=1 to len(aList)
    for m=1 to 2
        see string(aList[n][m]) + " "
    next
    see nl
next

# メインソースファイルのテスト
see "IsMainSourceFile() : " + ismainsourcefile() + nl
See "Previous File Name : " + PrevFileName() + nl
see "IsMainSourceFile() : " + ismainsourcefile() + nl

