/*
	名称 :	Ring パッケージ管理プログラム (RingPM) 
	日付  : 2018年10月18日
	作者: Mahmoud Fayed <msfclipper@yahoo.com>
*/

func PrintInstalledPackages
	# ファイルの取得
		Try
			new ListOfFiles {
				aFiles	= ListAllFiles(cMainPackagesFolder,"ring")
			}
		Catch 
			?C_ERROR_CANTGETPACKAGESINFORMATION
			return 
		Done 
	# パッケージ情報ファイルの取得
		aPackagesInfoFiles 	= []
		for cFile in aFiles
			if JustFileName(cFile) = "package.ring"
				aPackagesInfoFiles + cFile 
			ok
		next
	# パッケージ情報の表示 
		for cFile in aPackagesInfoFiles 
			eval(read(cFile))
			see Style(Width("("+aPackageInfo[:folder]+") ",30),:YellowBlack)+": " +
				 Width(aPackageInfo[:name] + " [" + aPackageInfo[:branch] + "]",50) +
				 " -- " +
				Width("("+aPackageInfo[:version]+ ")",15) 
				if lCheckUpdates 
					see  " -- "  
					See CheckUpdates(aPackageInfo) 
				ok
				see nl
		next 
	# パッケージ総数の表示 
		if len(aPackagesInfoFiles) != 0
			?nl + "パッケージ総数 : " + len(aPackagesInfoFiles)
		ok
	# パッケージがないときに表示するメッセージ 
		if len(aPackagesInfoFiles) = 0
			?"未インストールのパッケージ！"
		ok

func CheckUpdates aLocalPackageInfo
	cPackageName = aLocalPackageInfo[:remotefolder]
	cBranchName = aLocalPackageInfo[:branch]
	cProviderUserName = aLocalPackageInfo[:ProviderUserName] 
	cProviderWebsite  = aLocalPackageInfo[:ProviderWebsite]
	cPackageInfo = GetPackageFile(cPackageName,cBranchName,cProviderUserName,cProviderWebsite)
	if cPackageInfo = "" ? C_ERROR_PACKAGENOTFOUND return ok
	try
		eval( cPackageInfo )
	catch
		?C_ERROR_PACKAGEINFOISNOTCORRECT
		?cPackageInfo
		return 
	done 
	if ! islocal(:aPackageInfo)
		?C_ERROR_NOPACKAGEINFO
		return 
	ok
	# 更新の確認 	
		if aPackageInfo[:version] != aLocalPackageInfo[:version]
			if IsCompatible(aLocalPackageInfo[:Version],aPackageInfo[:Version])
				cColor = :WhiteBlue
			else 
				cColor = :WhiteRed
			ok
			return Style("新規更新 : (" + aPackageInfo[:version] + ")",cColor)
		ok
	return "更新不要！"
